*.....**************************
      subroutine InitLHA(iPdf)
*.....**************************

      implicit none

      integer iPdf

      if (iPdf.GT.240.OR.iPdf.LT.200) then
         write(6,*) '***********************************'
         write(6,*) '***********************************'
         write(6,*) '           InitLHA: Error!'
         write(6,*) '   Using standalone CTEQ 6 partons'
         write(6,*) '     with 200 <= PDF set <= 240'
         write(6,*) '      Requested  PDF set = ',iPdf
         write(6,*) '***********************************'
         write(6,*) '***********************************'
         stop
      endif

      Call SetCtq6(iPdf)

      write(6,*) 'InitLHA: Finished ipdf=',iPdf

      return
      end

*.....**************************************
      Real*8 Function GetParton(x,Q,iparton)
*.....**************************************
      
      implicit none

      integer iparton
      real*8 X, Q
      real*8 UV,DV,US,DS,SS,CS,BS,TS,GLU
      real*8 Ctq6Pdf

*.....Ctq6Pdf returns the simple parton density, *NOT* the momentum weighted parton density

      GetParton = -999
      if (iparton.eq.0) GetParton = Ctq6Pdf(1,X,Q)-Ctq6Pdf(-1,X,Q)
      if (iparton.eq.1) GetParton = Ctq6Pdf(2,X,Q)-Ctq6Pdf(-2,X,Q)
      if (iparton.eq.2) GetParton = Ctq6Pdf(-1,X,Q)
      if (iparton.eq.3) GetParton = Ctq6Pdf(-2,X,Q)
      if (iparton.eq.4) GetParton = Ctq6Pdf(-3,X,Q) 
      if (iparton.eq.5) GetParton = Ctq6Pdf(-4,X,Q)
      if (iparton.eq.6) GetParton = Ctq6Pdf(-5,X,Q)
      if (iparton.eq.7) GetParton = 0                        ! Set Top to zero
      if (iparton.eq.8) GetParton = Ctq6Pdf( 0,X,Q)
      if (x.GT.0.95) GetParton=0.0
c      write(6,*) 'GetParton: X , Q, i, pdf ',X,Q,iparton,GetParton
      
      return
      end


