 
C*********************************************************************
 
C...UPINIT
C...Dummy routine, to be replaced by a user implementing external
C...processes. Is supposed to fill the HEPRUP commonblock with info
C...on incoming beams and allowed processes.

C...New example: handles a standard Les Houches Events File.

      SUBROUTINE UPINIT
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
 
C...PYTHIA commonblock: only used to provide read unit MSTP(161).
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      SAVE /PYPARS/
 
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

cC...Lines to read in assumed never longer than 200 characters. 
c      PARAMETER (MAXLEN=200)
c      CHARACTER*(MAXLEN) STRING
c
cC...Format for reading lines.
c      CHARACTER*6 STRFMT
c      STRFMT='(A000)'
c      WRITE(STRFMT(3:5),'(I3)') MAXLEN
c
cC...Loop until finds line beginning with "<init>" or "<init ". 
c  100 READ(MSTP(161),STRFMT,END=130,ERR=130) STRING
c      IBEG=0
c  110 IBEG=IBEG+1
cC...Allow indentation.
c      IF(STRING(IBEG:IBEG).EQ.' '.AND.IBEG.LT.MAXLEN-5) GOTO 110 
c      IF(STRING(IBEG:IBEG+5).NE.'<init>'.AND.
c     &STRING(IBEG:IBEG+5).NE.'<init ') GOTO 100
c
cC...Read first line of initialization info.
c      READ(MSTP(161),*,END=130,ERR=130) IDBMUP(1),IDBMUP(2),EBMUP(1),
c     &EBMUP(2),PDFGUP(1),PDFGUP(2),PDFSUP(1),PDFSUP(2),IDWTUP,NPRUP
c
cC...Read NPRUP subsequent lines with information on each process.
c      DO 120 IPR=1,NPRUP
c        READ(MSTP(161),*,END=130,ERR=130) XSECUP(IPR),XERRUP(IPR),
c     &  XMAXUP(IPR),LPRUP(IPR)
c  120 CONTINUE
c      RETURN
c
C...Error exit: give up if initalization does not work.
c  130 WRITE(*,*) ' Failed to read LHEF initialization information.'
c      WRITE(*,*) ' Event generation will be stopped.'
c      STOP  

      integer Ipdg1,Ipdg2,Igrp1,Igrp2,Iset1,Iset2
      real*8 Energy1, Energy2

      external getbeaminfo
      external getxsecinfo

      integer Iweight,Nproc,ProcList
      real*8 Xsec,XsecErr,XsecMax

      logical debug
      data debug /.false./


      call GetBeamInfo(Ipdg1,Ipdg2,Energy1,Energy2,Igrp1,Igrp2,
     +     Iset1,Iset2)
      call GetXsecInfo(Iweight,Nproc,Xsec,XsecErr,XsecMax,ProcList)

*.....Now fill the common block      
      IDBMUP(1) = Ipdg1
      IDBMUP(2) = Ipdg2
      EBMUP(1)  = Energy1
      EBMUP(2)  = Energy2
      PDFGUP(1) = Igrp1
      PDFGUP(2) = Igrp2
      PDFSUP(1) = Iset1
      PDFSUP(2) = Iset2

      IDWTUP    = Iweight
      NPRUP     = Nproc
      XSECUP(1) = Xsec
      XERRUP(1) = XsecErr
      XMAXUP(1) = XsecMax
      LPRUP(1)  = ProcList

      if (debug) then
         write(6,*) 'UPINIT:   Ipdg1, Ipdg2 =',Ipdg1,Ipdg2
         write(6,*) 'UPINIT:   Igrp1, Igrp2 =',Igrp1,Igrp2
         write(6,*) 'UPINIT:   Iset1, Iset2 =',Iset1,Iset2
         write(6,*) 'UPINIT: Energy1,Energy2=',Energy1, Energy2
         write(6,*) 'UPINIT:      Iweight   =',Iweight
         write(6,*) 'UPINIT: Nproc / Proclist',Nproc, ProcList
         write(6,*) 'UPINIT: Xsec, Error, Max',Xsec, XsecErr, XsecMax
      endif

      RETURN
      END
